Subject: Re: standalone library/tool to query commit-graph?

From: Jakub Narebski <[email-masked]>
Date: Thu, 23 May 2019 21:29:02 +0200

Derrick Stolee <[email-masked]> writes:
> On 5/22/2019 2:49 PM, Karl Ostmo wrote:

>> After producing the file ".git/objects/info/commit-graph" with the
>> command "git commit-graph write", is there a way to answer queries
>> like "git merge-base --is-ancestor" without having a .git directory?
>> E.g. is there a library that will operate on the "commit-graph" file
>> all by itself?
>
> You could certainly build such a tool, assuming your merge-base parameters are
> full-length commit ids. If you try to start at ref names, you'll need the .git
> directory.
>
> I would not expect such a tool to ever exist in the Git codebase. Instead, you
> would need a new project, say "graph-analyzer --graph=<path> --is-ancestor <id1> <id2>"

It would be nice if such tool could convert commit-graph into other
commonly used augmented graph storage formats, like GEXF (Graph Exchange
XML Format), GraphML, GML (Graph Modelling Language), Pajek format or
Graphviz .dot format.

Wishfully thinking,
--
Jakub Narębski